#include <stdio.h>

#define LIMIT 45

/* versione iterativa */
long fiboi(int i)
{
	long f0 = 0L, f1 = 1L, temp;
	int j;

	if(!i)
		return 0;
	for(j = 2;j <= i;j++) {
		temp = f1;	
		f1 += f0;
		f0 = temp;
	}
	return f1;
}


/* versione iterativa con array circolare */
long fiboi2(int i)
{
	long a[3] = {0,1,1};
	int j;

	for(j = 3; j <= i; j++)
		a[j%3] = a[(j-1)%3] + a[(j-2)%3];
	return a[i < 2 ? i : (j-1)%3]; 
}

/* versione ricorsiva */
long fibor(int i)
{
	return i <= 1 ? i : fibor(i-1) + fibor(i-2); 	
}

/* versione ricorsiva con memorizzazione dei valori */
long fibor2(int i)
{
	static long f[LIMIT + 1];

	if(i <= 1)
		return f[i] = i;
	return f[i] = (f[i-1] ? f[i-1] : fibor2(i-1))
			+ (f[i-2] ? f[i-2] : fibor2(i-2));
}

int main(void)
{
	int i;

	printf("Tabella numeri di Fibonacci, calcolati iterativamente\n\n");
	for(i = 0; i <= LIMIT; i++)
		printf("fibo(%d) = %ld\n",i,fiboi(i));

	putchar('\n');
	printf("Premi per continuare:");
	getchar();

	printf("Tabella numeri di Fibonacci, calcolati ricorsivamente\n\n");
	for(i = 0; i <= LIMIT; i++)
		printf("fibo(%d) = %ld\n",i,fibor(i)); /* prova a sostituire fibor2 a fibor */
}
